package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.MarketMapBox;
import com.izouma.awesomeadmin.service.MarketMapBoxService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/marketMapBox")
public class MarketMapBoxController {

    @Autowired
    private MarketMapBoxService marketMapBoxService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(MarketMapBox record) {
        List<MarketMapBox> pp = marketMapBoxService.getMarketMapBoxList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getMarketMapBox", method = RequestMethod.GET)
    @ResponseBody
    public Result getMarketMapBox(@RequestParam(required = false, value = "id") String id) {
        MarketMapBox data = marketMapBoxService.getMarketMapBoxById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(MarketMapBox record) {
        MarketMapBox data = marketMapBoxService.getMarketMapBox(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, MarketMapBox record) {
        Map<String, Object> result = new HashMap<>();

        List<MarketMapBox> pp =marketMapBoxService.getMarketMapBoxByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(MarketMapBox record) {
        boolean num = marketMapBoxService.createMarketMapBox(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateMarketMapBox(MarketMapBox record) {
        boolean num = marketMapBoxService.updateMarketMapBox(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteMarketMapBox(MarketMapBox record) {

        boolean num = marketMapBoxService.deleteMarketMapBox(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, MarketMapBox record) throws Exception {

    List<MarketMapBox> marketMapBoxs = marketMapBoxService.getMarketMapBoxList(record);


        String sheetName = "market_map_box";
        String titleName = "货柜信息表数据表";
        String fileName = "货柜信息表表";
        int columnNumber = 23;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "编号" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "策划备注" ,   "所属商圈" ,   "地图名称" ,   "显示类型" ,   "类型" ,   "坐标X" ,   "坐标Y" ,   "坐标Z" ,   "缩放" ,   "角度" ,   "一定距离显示" ,   "所属图片" ,   "android坐标X" ,   "android坐标Y" ,   "android坐标Z" ,   "android缩放" ,   "android角度"  };
        String[][] dataList = new String[marketMapBoxs.size()][23];

        for (int i = 0; i < marketMapBoxs.size(); i++) {

                        dataList[i][0] = String.valueOf(marketMapBoxs.get(i).getId());
                        dataList[i][1] = String.valueOf(marketMapBoxs.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(marketMapBoxs.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(marketMapBoxs.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(marketMapBoxs.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(marketMapBoxs.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(marketMapBoxs.get(i).getRemark());
                        dataList[i][7] = String.valueOf(marketMapBoxs.get(i).getMarketId());
                        dataList[i][8] = String.valueOf(marketMapBoxs.get(i).getBoxName());
                        dataList[i][9] = String.valueOf(marketMapBoxs.get(i).getTypeId());
                        dataList[i][10] = String.valueOf(marketMapBoxs.get(i).getTypeName());
                        dataList[i][11] = String.valueOf(marketMapBoxs.get(i).getPosX());
                        dataList[i][12] = String.valueOf(marketMapBoxs.get(i).getPosY());
                        dataList[i][13] = String.valueOf(marketMapBoxs.get(i).getPosZ());
                        dataList[i][14] = String.valueOf(marketMapBoxs.get(i).getScale());
                        dataList[i][15] = String.valueOf(marketMapBoxs.get(i).getAngle());
                        dataList[i][16] = String.valueOf(marketMapBoxs.get(i).getShowLenth());
                        dataList[i][17] = String.valueOf(marketMapBoxs.get(i).getParentImageName());
                        dataList[i][18] = String.valueOf(marketMapBoxs.get(i).getAndroidPosX());
                        dataList[i][19] = String.valueOf(marketMapBoxs.get(i).getAndroidPosY());
                        dataList[i][20] = String.valueOf(marketMapBoxs.get(i).getAndroidPosZ());
                        dataList[i][21] = String.valueOf(marketMapBoxs.get(i).getAndroidScale());
                        dataList[i][22] = String.valueOf(marketMapBoxs.get(i).getAndroidAngle());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

